package com.mx.cneeds.server.user.web;

import com.mx.cneeds.common.dto.FuncDto;
import com.mx.cneeds.common.pager.PageUtils;
import com.mx.cneeds.common.result.R;
import com.mx.cneeds.common.validator.ValidatorUtils;
import com.mx.cneeds.server.entity.SysFuncEntity;
import com.mx.cneeds.server.user.service.SysFuncService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

//import org.apache.shiro.authz.annotation.RequiresPermissions;


/**
 * 功能表
 *
 * @author Mark
 * @email sunlightcs@gmail.com
 * @date 2020-01-09 15:09:01
 */
@RestController
@RequestMapping("sys/func")
public class SysFuncController {
    @Autowired
    private SysFuncService sysFuncService;

    /**
     * 列表
     */
    @RequestMapping("/list")
//    @RequiresPermissions("sys:sysfunc:list")
    public PageUtils list(@RequestParam Map<String, Object> params){
        PageUtils page = sysFuncService.queryPage(params);
        return page;
    }


    /**
     * 信息
     */
    @RequestMapping("/info/{funcId}")
//    @RequiresPermissions("sys:sysfunc:info")
    public R info(@PathVariable("funcId") Long funcId){
        SysFuncEntity sysFunc = sysFuncService.getById(funcId);

        return R.ok().put("sysFunc", sysFunc);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
//    @RequiresPermissions("sys:sysfunc:save")
    public R save(@RequestBody SysFuncEntity sysFunc){
        sysFuncService.save(sysFunc);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
//    @RequiresPermissions("sys:sysfunc:update")
    public R update(@RequestBody SysFuncEntity sysFunc){
        ValidatorUtils.validateEntity(sysFunc);
        sysFuncService.updateById(sysFunc);
        
        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
//    @RequiresPermissions("sys:sysfunc:delete")
    public R delete(@RequestBody Long[] funcIds){
        sysFuncService.removeByIds(Arrays.asList(funcIds));

        return R.ok();
    }

    @RequestMapping("/listAll")
    public List<FuncDto> list(){
        List<SysFuncEntity> list = sysFuncService.list();
        List<FuncDto> dtos = new ArrayList<>();
        list.forEach(sysFuncEntity -> {
            FuncDto funcDto = new FuncDto();
            BeanUtils.copyProperties(sysFuncEntity,funcDto);
            dtos.add(funcDto);
        });
        return dtos;
    }

}
